<?php
class DbConnection {
  // Connect
  private $db_link;
  private $db_selected;
  private $tables;
  private $table_indexes;
  private $table_dependencies;
  private $table_restore;
  private $connectionError;
  
  public function __construct($host, $user, $passwd, $db_name) {
    $this->db_link = @mysql_connect($host, $user, $passwd) or mysql_error();
    $this->db_selected = mysql_select_db($db_name);
    mysql_set_charset("utf8");
    
    $this->connectionError = null;
    
    $this->tables = array();
    $this->table_indexes = array();
    $this->table_dependencies = array();
    $this->table_restore = array();

    if(!defined("DB_ASSOC")) define('DB_ASSOC', MYSQL_ASSOC);
    if(!defined("DB_NUM")) define('DB_NUM', MYSQL_NUM);
    if(!defined("DB_BOTH")) define('DB_BOTH', MYSQL_BOTH);
    
    if(!$this->db_link || (isset($this->db_selected) && !$this->db_selected)) 
      $this->connectionError = _("<b>Database connection failed!</b><br>Please contact your admin.");
  }
  
  public function setTableDependencies($tables, $indexes, $dependencies, $restore) {
    $this->tables = $tables;
    $this->table_indexes = $indexes;
    $this->table_dependencies = $dependencies;
    $this->table_restore = $restore;
  }
  
  public function getConnectionError() {
    return $this->connectionError;
  }
  
  // Query Statement
  public function query($query) {
    global $TABLES;
    #if (KDB_TABLE_PREFIX) {
    #  foreach ($this->tables as $table)
    #    $query = preg_replace("/([^a-zA-Z0-9_-])$table([^a-zA-Z0-9_-])/", "\\1".KDB_TABLE_PREFIX."$table\\2", $query);
    #}
    return @mysql_query($query);
  }
  
  // fetch array statement
  public function fetch_array ($result, $result_type=MYSQL_ASSOC) {
    return @mysql_fetch_array($result, $result_type);
  }
  
  // fetch row statement
  public function fetch_row ($result) {
    return @mysql_fetch_row($result);
  }
  
  // result statement
  public function result ($result, $data_set_no, $field) {
    return @mysql_result($result, $data_set_no, $field);
  }
  
  // num rows statement
  public function num_rows ($result) {
    return @mysql_num_rows($result);
  }
  
  // affected rows statement
  public function affected_rows () {
    $affectedRows = mysql_affected_rows(); 
    if($affectedRows==0)
      $affectedRows = preg_replace("~^[^:]+:\s*([0-9]+).*$~", '$1', mysql_info());
    return $affectedRows;
  }
  
  public function info() {
    return @mysql_info();
  }
  
  // insert_id statement
  public function insert_id () {
    return @mysql_insert_id();
  }
  
  // free_result statement
  public function free_result ($result) {
    return @mysql_free_result($result);
  }
  
  // data_seek statement
  public function data_seek ($result, $data_set_no) {
    return @mysql_data_seek($result, $data_set_no);
  }
  
  // Error-Messages
  public function db_die() {
    echo mysql_error();
    echo "</body></html>";
    exit;
  }
  public function errno($result=0) {
    if ($result) $errno = mysql_errno($result);
    else $errno = mysql_errno();
    return $errno;
  }
  public function error($result=0) {
    if ($result) $error = mysql_error($result);
    else $error = mysql_error();
    return $error;
  }
  
  public function write_log($admin_id, $log_entry) {
    $this->query("INSERT INTO log (log_date, db_admin_id, log_entry) VALUES (NOW(), '{$admin_id}', '{$log_entry}');");
  }
}
?>